-- THIS FILE STILL NEEDS A LOT OF LOVE

StatRingsOptions = {};

local function DEBUG(msg)
   DEFAULT_CHAT_FRAME:AddMessage("SROF: " .. msg);
end

local OPTIONS_SLIDERS = {};

local function SetupSliderText(frame, low, high, label)
   if (type(frame) == "table") then frame = frame:GetName(); end
   if (low) then getglobal(frame .. "Low"):SetText(low); end
   if (high) then getglobal(frame .. "High"):SetText(high); end
   if (label) then getglobal(frame .. "Text"):SetText(label); end
end

local function SliderOnValueChanged()
   local val = this:GetValue() * this.scaleFactor;
   STATRINGS_OPTIONS[this.optVar] = val;
   StatRingsCluster[this.optMethod](StatRingsCluster, STATRINGS_OPTIONS);
end

local function SetupSliderData(frame, low, high, step,
			       optVar, optMethod, scaleFactor)
   OPTIONS_SLIDERS[frame] = 1;
   frame:SetMinMaxValues(low, high);
   frame:SetValueStep(step);
   frame.optVar = optVar;
   frame.optMethod = optMethod;
   frame.scaleFactor = scaleFactor or 1.0;
   frame:SetScript("OnValueChanged", SliderOnValueChanged);
end

function StatRingsOptionsFrame_OnLoad()
   local s = StatRingsOptionsScale;
   SetupSliderText(s, "Small", "Large", "Cluster Size");
   SetupSliderData(s, 0.05, 1.0, 0.01, "scale", "ApplyLocationOptions");

   s = StatRingsOptionsLocY;
   SetupSliderText(s, "Top", "Bottom", "Y Loc");
   SetupSliderData(s, -1, 1, 0.05, "locY", "ApplyLocationOptions", -1);

   s = StatRingsOptionsLocX;
   SetupSliderText(s, "Left", "Right", "X Loc");
   SetupSliderData(s, -1, 1, 0.05, "locX", "ApplyLocationOptions");

   function this:Toggle()
      if (self:IsShown()) then
	 self:Hide();
      else
	 self:Show();
      end
   end
end

---------------------------------------------------------------------------
local ConfigSelect = {};
StatRingsOptions.ConfigSelect = ConfigSelect;

ConfigSelect.Options = {
   { 
      text = "Reaction settings",
      value = "reactions",
      tooltipTitle = "Reaction settings",
      tooltipText = "Ring reaction settings"
   },

--[[   { 
      text = "Presentation settings",
      value = "presentation",
      tooltipTitle = "Presentation settings",
      tooltipText = "Ring presentation settings"
}, ]]
}

function ConfigSelect.Initialize()
   local selectedValue = UIDropDownMenu_GetSelectedValue(ConfigSelect.frame);

   for _,info in ipairs(ConfigSelect.Options) do
      if (selectedValue == info.value) then
	 info.checked = 1;
      else
	 info.checked = nil;
      end
      info.func = ConfigSelect.SelectOnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function ConfigSelect.SelectOnClick()
   UIDropDownMenu_SetSelectedValue(ConfigSelect.frame, this.value);
   ConfigSelect.current = this.value;
   --DEFAULT_CHAT_FRAME:AddMessage("ConfigSelect.SelectOnClick");
   if (ConfigSelect.specFrame) then
      --DEFAULT_CHAT_FRAME:AddMessage("ConfigSelect.SelectOnClick - Spec");
      ConfigSelect.specFrame:SelectConfigurationType(this.value);
   end
end

function ConfigSelect.OnLoad()
   ConfigSelect.frame = this;
   ConfigSelect.current = "reactions";
   UIDropDownMenu_Initialize(this, ConfigSelect.Initialize);
   UIDropDownMenu_SetSelectedValue(this, ConfigSelect.current);
   UIDropDownMenu_SetWidth(140, this);
end

---------------------------------------------------------------------------
local RingSelect = {};
StatRingsOptions.RingSelect = RingSelect;

RingSelect.Options = {
   { 
      text = "Player",
      value = "player",
      tooltipTitle = "Player",
      tooltipText = "Configure player ring"
   },

   { 
      text = "Party",
      value = "party",
      tooltipTitle = "Party",
      tooltipText = "Configure party rings"
   },

   { 
      text = "Pet",
      value = "pet",
      tooltipTitle = "Pet",
      tooltipText = "Configure pet ring"
   },

   { 
      text = "Party Pet",
      value = "partypet",
      tooltipTitle = "Party Pet",
      tooltipText = "Configure party pet rings"
   },

   { 
      text = "Target",
      value = "target",
      tooltipTitle = "Target",
      tooltipText = "Configure target ring"
   },
}

function RingSelect.Initialize()
   local selectedValue = UIDropDownMenu_GetSelectedValue(RingSelect.frame);

   for _,info in ipairs(RingSelect.Options) do
      if (selectedValue == info.value) then
	 info.checked = 1;
      else
	 info.checked = nil;
      end
      info.func = RingSelect.SelectOnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function RingSelect.SelectOnClick()
   UIDropDownMenu_SetSelectedValue(RingSelect.frame, this.value);
   RingSelect.current = this.value;
   if (RingSelect.specFrame) then
      RingSelect.specFrame:SelectConfigurationGroup(this.value);
   end
--   if (RingSelect.current ~= this.value) then
--      RingSelect.current = this.value;
--      StatRingsOptions.RingCopySelect.UpdateOptions();
--   end
end

function RingSelect.OnLoad()
   RingSelect.frame = this;
   RingSelect.current = "player";
   UIDropDownMenu_Initialize(this, RingSelect.Initialize);
   UIDropDownMenu_SetSelectedValue(this, RingSelect.current);
   UIDropDownMenu_SetWidth(80, this);
   -- StatRingsOptions.RingCopySelect.UpdateOptions();
end

local RingCopySelect = {};
StatRingsOptions.RingCopySelect = RingCopySelect;

RingCopySelect.Options = {
   { 
      text = "Custom Settings",
      value = "",
      tooltipTitle = "Custom Settings",
      tooltipText = "Specify the settings for this ring group directly."
   },

   { 
      text = "Player Settings",
      value = "player",
      tooltipTitle = "Use Player Settings",
      tooltipText = "The ring group will copy the player ring settings."
   },

   { 
      text = "Party Settings",
      value = "party",
      tooltipTitle = "Use Party Settings",
      tooltipText = "The ring group will copy the party ring settings."
   },

   { 
      text = "Pet Settings",
      value = "pet",
      tooltipTitle = "Use Pet Settings",
      tooltipText = "The ring group will copy the pet ring settings."
   },

   { 
      text = "Party Pet Settings",
      value = "partypet",
      tooltipTitle = "Use Party Pet Settings",
      tooltipText = "The ring group will copy the party pet ring settings."
   },

   { 
      text = "Target Settings",
      value = "target",
      tooltipTitle = "Use Target Settings",
      tooltipText = "The ring group will copy the target ring settings."
   },
}

function RingCopySelect.Initialize()
   local selectedValue = UIDropDownMenu_GetSelectedValue(RingCopySelect.frame);

   for _,info in ipairs(RingCopySelect.Options) do
      if (selectedValue == info.value) then
	 info.checked = 1;
      else
	 info.checked = nil;
      end
      info.func = RingCopySelect.SelectOnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function RingCopySelect.UpdateOptions()
   if (not RingCopySelect.frame) then return; end
   local ring = RingSelect.current;
   local RingCopySelect = RingCopySelect; -- local ref
   local frame = RingCopySelect.frame;
   local defaultInfo, checkedInfo;

   for _,info in ipairs(RingCopySelect.Options) do
      local value = info.value;
      if (value == "") then
	 info.disabled = nil;
	 defaultInfo=info;
      elseif (value == ring) then
	 info.disabled = true;
      elseif (ring == "player") then
	 info.disabled = true;
      else
	 info.disabled = nil;
      end
      if (info.checked) then checkedInfo = info; end
   end

   if (ring == "player") then
      OptionsFrame_DisableDropDown(frame);
      -- Wackiness to get around freakish dropdown implementation
      -- This does not work: UIDropDownMenu_SetSelectedValue(frame, "");
      if (checkedInfo) then checkedInfo.checked = nil; end
      defaultInfo.checked = 1;
      frame.selectedValue = "";
      UIDropDownMenu_SetText(defaultInfo.text, frame);
      RingCopySelect.current = "";
   else
      OptionsFrame_EnableDropDown(frame);
   end
end

function RingCopySelect.SelectOnClick()
   RingCopySelect.current = this.value;
   UIDropDownMenu_SetSelectedValue(RingCopySelect.frame, this.value);
   local spec = RingCopySelect.specFrame;
   if (spec) then
      spec:SetCopyOf(this.value)
   end
end

function RingCopySelect.OnLoad()
   RingCopySelect.frame = this;
   RingCopySelect.current = "";
   UIDropDownMenu_Initialize(this, RingCopySelect.Initialize);
   UIDropDownMenu_SetSelectedValue(this, RingCopySelect.current);
   UIDropDownMenu_SetWidth(120, this);
   RingCopySelect.UpdateOptions();
end


function StatRingsOptionsFrame_OnShow()
   for slider in pairs(OPTIONS_SLIDERS) do
      local key = slider.optVar;
      slider:SetValue((STATRINGS_OPTIONS[key] 
		       or DEFAULT_STATRINGS_OPTIONS[key]) / slider.scaleFactor);
   end
end

local function SliderOnValueChanged()
   local val = this:GetValue() * this.scaleFactor;
   STATRINGS_OPTIONS[this.optVar] = val;
   StatRingsCluster[this.optMethod](StatRingsCluster, STATRINGS_OPTIONS);
end

local function SetupSliderData(frame, low, high, step,
			       optVar, optMethod, scaleFactor)
   OPTIONS_SLIDERS[frame] = 1;
   frame:SetMinMaxValues(low, high);
   frame:SetValueStep(step);
   frame.optVar = optVar;
   frame.optMethod = optMethod;
   frame.scaleFactor = scaleFactor or 1.0;
   frame:SetScript("OnValueChanged", SliderOnValueChanged);
end

local RSLayout = {
   {
      type="slider",
      lowLabel="Clear", highLabel="Solid", title="Full health alpha",
      lowLimit=0, highLimit=1, step=0.01, setting="alphaFull" ,
      previewType='alpha',
      xPos=165, yPos=-30,
   },

   {
      type="slider",
      lowLabel="Clear", highLabel="Solid", title="Damaged alpha",
      lowLimit=0, highLimit=1, step=0.01, setting="alphaNormal",
      previewType='alpha',
      xPos=165, yPos=-80,

   },

   {
      type="slider",
      lowLabel="Clear", highLabel="Solid", title="Health alert alpha",
      lowLimit=0, highLimit=1, step=0.01, setting="alphaAlert",
      previewType='alpha',
      xPos=165, yPos=-130,
   }, 

   {
      type="slider",
      lowLabel="0%", highLabel="100%", title="Alert health value",
      lowLimit=0, highLimit=1, step=0.01, setting="healthAlert",
      previewType='health',
      xPos=20, yPos=-130,
   }, 

   {
      type="slider",
      lowLabel="0%", highLabel="100%", title="Unfade mana value",
      lowLimit=0, highLimit=1, step=0.01, setting="manaUnfade",
      previewType='mana',
      xPos=20, yPos=-80,
   }, 
}

local RSFrameMethods = {}

local function RSFM_DoLabel(name, value)
   local frame = getglobal(name);
   frame:SetText(value or "");
end

local function RSFM_SliderOnValueChanged()
   if (this.sliderDisabled) then
      return;
   end
   local value = this:GetValue();
   local info = this.widgetInfo;
   --DEBUG("On value changed " .. info.setting .. " = " .. value);
   info.frame:SetSetting(info.setting, value);
end

local function RSFM_OnMouseoverGain(frame, replaced)
   local info = frame.widgetInfo;
   if (info and info.frame) then
      info.frame:UpdateMouseover(info.setting, this);
   end
end

local function RSFM_OnMouseoverLoss(frame, replaced)
   local info = frame.widgetInfo;
   if (info and info.frame) then
      info.frame:ClearMouseover(frame);
   end
end

local function RSFM_SetupSlider(self, frame)
   local name = frame:GetName();
   RSFM_DoLabel(name.."Low",  self.lowLabel);
   RSFM_DoLabel(name.."High", self.highLabel);
   RSFM_DoLabel(name.."Text", self.title);

   frame:SetMinMaxValues(self.lowLimit, self.highLimit);
   frame:SetValueStep(self.step);
   frame.OnMouseoverGain = RSFM_OnMouseoverGain;
   frame.OnMouseoverLoss = RSFM_OnMouseoverLoss;
   frame:SetScript("OnValueChanged", RSFM_SliderOnValueChanged);
   StatRingsOption_MOT_SetupSlider(frame);
end

function RSFrameMethods:SetupWidget(layout)
   layout.frame = self;
   local setupFunc = nil;
   if (layout.type == "slider") then
      setupFunc = RSFM_SetupSlider;
   end
   local widget = self:AllocateWidget(layout, setupFunc)
   if (not widget) then
      return nil;
   end
   widget:ClearAllPoints();
   widget:SetPoint("TOPLEFT", self:GetName(),
		   "TOPLEFT", layout.xPos or 0, layout.yPos or 0);
end

function RSFrameMethods:SetWidgetValues()
   if (not self.curValid) then
      return;
   end
   local cur = self.curSettings;
   local eff = self.effSettings;
   local prv = self.previewTypes;
   if (not prv) then
      prv = {};
      self.previewTypes = prv;
   end
   
   for widget, spec in self:ActiveWidgetIterator() do
      local setting = spec.setting;
      local type = spec.type;
      prv[setting] = spec.previewType;

      local val = cur[setting] or eff[setting];
      
      if (type == "slider") then
	 if (not val) then
	    widget:Hide();
	 else
	    widget:SetValue(val);
	    widget:Show();
	 end
      else
	 widget:Hide();
      end
   end
end

function RSFrameMethods:SetWidgetEnableState()
   if (not self.curValid) then
      return;
   end
   local enabled = (not self.curSettings.copyOf);

   local cur = self.curSettings;
   local eff = self.effSettings;

   for widget, spec in self:ActiveWidgetIterator() do
      local type = spec.type;
      local setting = spec.setting;
      local val = cur[setting] or eff[setting];

      if (type == "slider") then
	 if (enabled) then
	    OptionsFrame_EnableSlider(widget);
	    widget:SetValue(val or 0);
	    widget.sliderDisabled = false;
	 else
	    OptionsFrame_DisableSlider(widget);
	    widget.sliderDisabled = true;
	 end
      end
   end
end

function RSFrameMethods:SelectConfigurationType(configType, force)
   return self:SelectConfiguration(configType, self.configGroup, force);
end

function RSFrameMethods:SelectConfigurationGroup(configGroup, force)
   return self:SelectConfiguration(self.configType, configGroup, force);
end

function RSFrameMethods:SelectConfiguration(configType, configGroup, force)
   --DEFAULT_CHAT_FRAME:AddMessage("RSFrame: SelectConfiguration("
   --.. (configType or '<nil>')
   --.. ","
   --.. (configGroup or '<nil>')
   --.. ","
   --.. (force or "false")
   --.. ")");
   if ((configGroup == self.configGroup)
       and (configType == self.configType)
	  and (not force)) then
      return;
   end
   self.configGroup = configGroup;
   self.configType = configType;
   self:ApplyConfiguration();
end

function RSFrameMethods:ApplyConfiguration(noShow)
   if ((not self.configGroup) or (not self.configType)) then
      self.dirty = nil;
      self.needPopulate = nil;
      self.needEffective = nil;
      self.curValid = nil;
      self:Hide();
      return;
   end

   self.dirty = nil;
   self.needPopulate = nil;
   self.needEffective = nil;

   if (self.currentLayout ~= self.configType) then
      --DEFAULT_CHAT_FRAME:AddMessage("Would update to layout: "
      --.. self.configType);
      self.currentLayout = self.configType;

      self:ClearMouseover();
      self:ReleaseAllWidgets();
      if (self.currentLayout == "reactions") then
	 for _,v in ipairs(RSLayout) do
	    --DEBUG("Creating widget " .. v.setting);
	    local widget = self:SetupWidget(v);
	    if (widget) then widget:Show(); end
	 end
      end
   end

   if (not self.curSettings) then
      self.curSettings = {};
   end
   if (not self.effSettings) then
      self.effSettings = {};
   end

   if (not StatRingsConfig:GetSettings(self.configType,
				       self.configGroup,
				       self.curSettings)) then
      self.curValid = nil;
      self:Hide();
      return;
   end

   if (not StatRingsConfig:GetEffectiveSettings(self.configType,
						self.configGroup,
						self.effSettings)) then
      self.curValid = nil;
      self:Hide();
      return;
   end

   self.curValid = 1;

   if (not noShow) then
      self:Show();
   end

   self:SetWidgetValues();
   self:UpdateCopySelect();
end

function RSFrameMethods:UpdateCopySelect(noApply)
   if (not RingCopySelect.frame) then return; end
   if (not self.curValid) then return; end

   local group = self.configGroup;
   local eligible = StatRingsConfig:GetEligibleCopies(self.configType, group);
   local noOptions = true;

   local RingCopySelect = RingCopySelect; -- local ref
   local frame = RingCopySelect.frame;
   local defaultInfo, checkedInfo, curInfo;

   local curOption = self.curSettings.copyOf or "";

   --DEBUG("RSF:UpdateCopySelect: curOption='"..curOption.."'");

   for _,info in ipairs(RingCopySelect.Options) do
      local value = info.value;
      if (value == "") then
	 info.disabled = nil;
	 defaultInfo=info;
      elseif (eligible[value]) then
	 info.disabled = nil;
	 noOptions = nil;
      else
	 info.disabled = true;
      end
      if (value == curOption) then
	 curInfo = info;
      end
      if (info.checked) then 
	 if (checkedInfo) then
	    info.checked = nil;
	 else
	    checkedInfo = info; 
	 end
      end
   end

   if ((not curInfo) or (curInfo and curInfo.disabled)) then
      -- The current option is invalid!!
      curOption = "";
      curInfo = defaultInfo;
      self:SetCopyOf("", true);
   end

   -- Wackiness to get around freakish dropdown implementation
   -- This does not work: UIDropDownMenu_SetSelectedValue(frame, "");
   if (checkedInfo) then checkedInfo.checked = nil; end
   curInfo.checked = 1;
   frame.selectedValue = curOption;
   RingCopySelect.current = curOption;
   UIDropDownMenu_SetText(curInfo.text, frame);

   if (noOptions) then
      OptionsFrame_DisableDropDown(frame);
   else
      OptionsFrame_EnableDropDown(frame);
   end

   self:SetWidgetEnableState();
   if ((not noApply) and self.dirty) then
      self:ApplyChange();
   end
end

function RSFrameMethods:SetCopyOf(copyOf, noApply)
   if (not self.curValid) then return; end
   if (copyOf == '') then 
      copyOf = nil;
   end
   local oldCopyOf = self.curSettings.copyOf;
   local changed;
   if (copyOf ~= oldCopyOf) then
      self.dirty = true;
      if (not copyOf) then
	 self.needPopulate = true;
      elseif (not oldCopyOf) then
	 self.needEffective = true;
      end
      self.curSettings.copyOf = copyOf;
      changed = true;
   end
   if (self.dirty and (changed or (not noApply))) then
      self:ApplyChange();
   end
   if (changed) then
      self:SetWidgetEnableState();
   end
end

function RSFrameMethods:SetSetting(setting, value, noApply)
   if (not self.curValid) then return; end
   local cur = self.curSettings;
   local oldVal = cur[setting] or self.effSettings[setting];
   if (oldVal == value) then
      return;
   end
   cur[setting] = value;
   self.dirty = true;
   if ((not noApply) and self.dirty) then
      self:ApplyChange();
   end
end

local ALPHA_PREVIEW = {
   shown = true,
   healthPct = 1,
   manaPct = 1,
   manaMax = 100,
   alpha = 1,
   unitName = true, -- Special value to show unit ID
};

local HEALTH_PREVIEW = {
   shown = true,
   healthPct = 1,
   manaPct = 1,
   manaMax = 1,
   alpha = 0.7,
   unitName = true, -- Special value to show unit ID
};

local MANA_PREVIEW = {
   shown = true,
   healthPct = 1,
   manaPct = 1,
   manaMax = 1,
   alpha = 0.7,
   unitName = true, -- Special value to show unit ID
};

local DISABLED_PREVIEW = {
   shown = true,
   force = "grey",
   alpha = 0.6,
   isGrey = true, -- Force show in greyscale
};

function RSFrameMethods:UpdateMouseover(field, frame)
   if ((not self.curValid) or (not self.previewTypes)) then
      return;
   end
   local oldMouseover = self.mouseoverFrame;

   self.mouseoverFrame = frame;
   self.mouseoverField = field;
   --DEBUG("RSF:Mouseover " .. field);

   local prv = self.previewTypes[field];
   if (not prv) then
      DEBUG("No preview type for field '" .. field .. "'");
      if (oldMouseover) then
	 self:ClearMouseover();
      end
      return;
   end

   local cur = self.curSettings;
   local eff = self.effSettings;

   if (prv == 'alpha') then
      self.previewActive = prv;
      ALPHA_PREVIEW.alpha = 
	 ((cur.copyOf == nil) and cur[field]) or eff[field];
      StatRingsConfig:InitVisualPreview(self.configType,
					self.configGroup,
					ALPHA_PREVIEW,
					DISABLED_PREVIEW);
      return true;
   end

   if (prv == 'health') then
      self.previewActive = prv;
      HEALTH_PREVIEW.healthPct = 
	 ((cur.copyOf == nil) and cur[field]) or eff[field];
      StatRingsConfig:InitVisualPreview(self.configType,
					self.configGroup,
					HEALTH_PREVIEW,
					DISABLED_PREVIEW);
      return true;
   end

   if (prv == 'mana') then
      self.previewActive = prv;
      MANA_PREVIEW.manaPct = 
	 ((cur.copyOf == nil) and cur[field]) or eff[field];
      StatRingsConfig:InitVisualPreview(self.configType,
					self.configGroup,
					MANA_PREVIEW,
					DISABLED_PREVIEW);
      return true;
   end
   
   -- If we get here, our preview is not happy
   if (self.previewActive) then
      StatRingsConfig:ResetVisualPreview();
      self.previewActive = nil;
   end
end

function RSFrameMethods:ClearMouseover(frame)
   if ((self.mouseoverField) 
       and ((not frame) or (self.mouseoverFrame == frame))) then
      --DEBUG("RSF:Cleared mouseover from " .. self.mouseoverField);
      self.mouseoverField = nil;
      self.mouseoverFrame = nil;
      if (self.previewActive) then
	 StatRingsConfig:ResetVisualPreview();
	 self.previewActive = nil;
      end
   end
end

function RSFrameMethods:ApplyChange()
   if (not self.dirty) then
      return;
   end
   --DEBUG("RSF:ApplyChange() - Apply change");
   
   local cur = self.curSettings;
   
   if (self.needPopulate) then
      local eff = self.effSettings;
      for k,v in pairs(eff) do
	 if (k ~= "copyOf") then
	    if (cur[k] == nil) then
	       cur[k] = v;
	    end
	 end
      end
      self.needPopulate = nil;
   end

   StatRingsConfig:SetSettings(self.configType,
			       self.configGroup,
			       self.curSettings);

   if (self.needEffective) then
      --DEBUG("Getting updated effective settings...");
      local newEff = StatRingsConfig:GetEffectiveSettings(self.configType,
							  self.configGroup,
							  self.effSettings);
      self.needEffective = nil;
   end

   local prv = self.previewActive;

   if (not prv) then
      -- Quick skip
   elseif (prv == "alpha") then
      local val = cur[self.mouseoverField];
      if (val and (ALPHA_PREVIEW.alpha ~= val)) then
	 ALPHA_PREVIEW.alpha = val;
	 StatRingsConfig:UpdateVisualPreview(ALPHA_PREVIEW);
      end
   elseif (prv == "health") then
      local val = cur[self.mouseoverField];
      if (val and (HEALTH_PREVIEW.healthPct ~= val)) then
	 HEALTH_PREVIEW.healthPct = val;
	 StatRingsConfig:UpdateVisualPreview(HEALTH_PREVIEW);
      end
   elseif (prv == "mana") then
      local val = cur[self.mouseoverField];
      if (val and (MANA_PREVIEW.manaPct ~= val)) then
	 MANA_PREVIEW.manaPct = val;
	 StatRingsConfig:UpdateVisualPreview(MANA_PREVIEW);
      end
   end

   self.dirty = nil;
end

function StatRingsOptionsRingSpec_SetupMethods(this)
   for k,v in RSFrameMethods do
      this[k] = v;
   end
end

------------------------------------------------------------------------------


SlashCmdList["STATRINGS_OPTIONS"] = 
   function(msg) 
      StatRingsOptionsFrame:Toggle() 
   end

SLASH_STATRINGS_OPTIONS1 = "/statrings";

STATRINGS_CONFIG_SELECT = "Select configuration set...";
STATRINGS_RING_SELECT = ".. and ring group:";
STATRINGS_SAME_AS = "Ring configuration:";

